| Earth Observation Mission CFI Software Pointing Software User Manual |

Public Member Functions | Public Attributes

# EECFI::AttitudeDef Class Reference

Atitude definition. More...

Inheritance diagram for EECFI::AttitudeDef:

List of all members.

## Public Member Functions
| AttitudeDef ()
| Empty constructor.
| AttitudeDef (long type, SatNomTransId &satNomIn, SatTransId &satIn, InstrTransId &instrIn)
| Constructor with paramters.
| ~AttitudeDef ()
| Destructor.
void | attitudeTransform (TransformCfg &transformCfg) throw (CfiError)
| The reference frame in the attitude id can be changed using attitudeTransform.
AttFile | genAttitudeData (OrbitId &orbId, const OrbTimeInterval &timeInterval, double timeStep, long dataType, long sourceRefType, long sourceRef) const throw (CfiError)
| Compute a list of quaternions/angles equivalent to the transformation from sourceRef to the attitude target frame.
void | genAttitudeFile (OrbitId &orbId, const OrbTimeInterval &timeInterval, double timeStep, long dataType, long sourceRefType, long sourceRef, string outputDir, string fileClass, long versionNumber, string fhSystem, string &outputFileName) const throw (CfiError)
| Create an attitude file with quaternions/angles equivalent to the transformation from sourceRef to the attitude target frame.
## Public Attributes
long | type
| XPCFI_SAT_NOMINAL_ATT/XPCFI_SAT_ATT/XPCFI_INSTR_ATT.
SatNomTransId | satNomTransId
| Satellite nominal attitude.
SatTransId | satTransId
| Satellite attitude.
InstrTransId | instrTransId
| Instrument attitude.

## Detailed Description

Atitude definition.

## Constructor & Destructor Documentation

EECFI::AttitudeDef::AttitudeDef | ( |  | ) |

Empty constructor.

References type.

EECFI::AttitudeDef::AttitudeDef | ( | long | type,
|  | SatNomTransId & | satNomIn,
|  | SatTransId & | satIn,
|  | InstrTransId & | instrIn |
| ) |  |  |

Constructor with paramters.

References instrTransId, satNomTransId, satTransId, and type.

EECFI::AttitudeDef::~AttitudeDef | ( |  | ) |

Destructor.

## Member Function Documentation

void EECFI::AttitudeDef::attitudeTransform | ( | TransformCfg & | transformCfg | ) | throw (CfiError)

The reference frame in the attitude id can be changed using attitudeTransform.

Remark: all attitude related computations are performed in the True of Date Coordinate System. This means that, if one attitude id has been initialized with data expressed in another reference frame (e.g. attitude file with quaternions expressed in EF), at each call of a function using such attitude id (e.g. Attitude::compute) one or more conversions to True of Date will be performed. If the reference frame is changed to True of Date (using AttitudeDef::attitudeTransform), such conversions will not be executed and this will result in a run-time performance improvement.
Note: transformation of attitude ids that are initialized with Start Tracker files is not supported.

Parameters:

  | transformCfg | Transformation parameters.

AttFile EECFI::AttitudeDef::genAttitudeData | ( | OrbitId & | orbId,
|  | const OrbTimeInterval & | timeInterval,
|  | double | timeStep,
|  | long | dataType,
|  | long | sourceRefType,
|  | long | sourceRef |
| ) |  |  | const throw (CfiError)

Compute a list of quaternions/angles equivalent to the transformation from sourceRef to the attitude target frame.

A data set (quaternions/angles) is generated every "timeStep" seconds along the input "timeInterval"

Parameters:

  | timeInterval | Time interval to be generated
  | timeStep | interval between records in file (seconds)
  | dataType | Euler angles or quaternions
  | sourceRefType | source reference frame type (External or satellite)
  | sourceRef | source reference frame

Returns:
  AttFile object with the list of quaternions or angles.

References EECFI::AttFile::attRec, EECFI::AttFile::dataType, EECFI::AttFile::maxGap, EECFI::AttFile::satRef, and EECFI::AttFile::sourceRef.

void EECFI::AttitudeDef::genAttitudeFile | ( | OrbitId & | orbId,
|  | const OrbTimeInterval & | timeInterval,
|  | double | timeStep,
|  | long | dataType,
|  | long | sourceRefType,
|  | long | sourceRef,
|  | string | outputDir,
|  | string | fileClass,
|  | long | versionNumber,
|  | string | fhSystem,
|  | string & | outputFileName |
| ) |  |  | const throw (CfiError)

Create an attitude file with quaternions/angles equivalent to the transformation from sourceRef to the attitude target frame.

The file records are generated every "timeStep" seconds along the input "timeInterval"

Parameters:

  | OrbitId | Orbit Id.
  | timeInterval | Time interval to be generated
  | timeStep | interval between records in file (seconds)
  | dataType | Euler angles or quaternions
  | sourceRefType | source reference frame type (External or satellite)
  | sourceRef | source reference frame
  | outputDir | output directory
  | fileClass | file calss
  | versionNumber | file version
  | fhSystem | FH system
  | outputFileName | Output file name. If emtpy is generated automatically

## Member Data Documentation

InstrTransId EECFI::AttitudeDef::instrTransId

Instrument attitude.

Referenced by AttitudeDef().

SatNomTransId EECFI::AttitudeDef::satNomTransId

Satellite nominal attitude.

Referenced by AttitudeDef().

SatTransId EECFI::AttitudeDef::satTransId

Satellite attitude.

Referenced by AttitudeDef().

long EECFI::AttitudeDef::type

XPCFI_SAT_NOMINAL_ATT/XPCFI_SAT_ATT/XPCFI_INSTR_ATT.

Referenced by AttitudeDef().